Index: c/src/lib/libbsp/sh/shsim/.cvsignore
===================================================================
--- c/src/lib/libbsp/sh/shsim/.cvsignore	(revision 86ec6edbe9851ff7e2dd0bd5412d30461cfb2f59)
+++ c/src/lib/libbsp/sh/shsim/.cvsignore	(revision 86ec6edbe9851ff7e2dd0bd5412d30461cfb2f59)
@@ -0,0 +1,13 @@
+Makefile
+Makefile.in
+aclocal.m4
+config.cache
+config.guess
+config.log
+config.status
+config.sub
+configure
+depcomp
+install-sh
+missing
+mkinstalldirs
Index: c/src/lib/libbsp/sh/shsim/ChangeLog
===================================================================
--- c/src/lib/libbsp/sh/shsim/ChangeLog	(revision 86ec6edbe9851ff7e2dd0bd5412d30461cfb2f59)
+++ c/src/lib/libbsp/sh/shsim/ChangeLog	(revision 86ec6edbe9851ff7e2dd0bd5412d30461cfb2f59)
@@ -0,0 +1,13 @@
+2000-11-27	Joel Sherrill <joel@OARcorp.com>
+
+	* The shsim is for the SH simulator in gdb. It should be able
+	to be used with multiple SH CPU models.
+	* .cvsignore, ChangeLog, Makefile.am, README, bsp_specs,
+	configure.in, clock/.cvsignore, clock/Makefile.am,
+	clock/clockdrv.c, console/.cvsignore, console/Makefile.am,
+	console/console-io.c, console/console-support.S,
+	include/.cvsignore, include/Makefile.am, include/bsp.h,
+	start/.cvsignore, start/Makefile.am, start/regs.S,
+	start/start.S, startup/.cvsignore, startup/Makefile.am,
+	startup/bspstart.c, startup/linkcmds, wrapup/.cvsignore,
+	wrapup/Makefile.am: New files.
Index: c/src/lib/libbsp/sh/shsim/Makefile.am
===================================================================
--- c/src/lib/libbsp/sh/shsim/Makefile.am	(revision 86ec6edbe9851ff7e2dd0bd5412d30461cfb2f59)
+++ c/src/lib/libbsp/sh/shsim/Makefile.am	(revision 86ec6edbe9851ff7e2dd0bd5412d30461cfb2f59)
@@ -0,0 +1,18 @@
+##
+## $Id$
+##
+
+AUTOMAKE_OPTIONS = foreign 1.4
+ACLOCAL_AMFLAGS = -I ../../../../../../aclocal
+
+# wrapup is the one that actually builds and installs the library
+#  from the individual .rel files built in other directories
+#SUBDIRS = include start startup clock console timer wrapup
+SUBDIRS = include start startup clock console wrapup
+
+include $(top_srcdir)/../../bsp.am
+
+EXTRA_DIST = bsp_specs times
+
+include $(top_srcdir)/../../../../../../automake/subdirs.am
+include $(top_srcdir)/../../../../../../automake/local.am
Index: c/src/lib/libbsp/sh/shsim/README
===================================================================
--- c/src/lib/libbsp/sh/shsim/README	(revision 86ec6edbe9851ff7e2dd0bd5412d30461cfb2f59)
+++ c/src/lib/libbsp/sh/shsim/README	(revision 86ec6edbe9851ff7e2dd0bd5412d30461cfb2f59)
@@ -0,0 +1,14 @@
+#
+#  $Id$
+#
+
+Simple BSP for the SH simulator built into gdb.
+
+Simulator Invocation
+====================
+target sim
+
+Status
+======
+Does not link yet.  libcpu/sh code needs to be addressed so we can
+get context switch code.
Index: c/src/lib/libbsp/sh/shsim/bsp_specs
===================================================================
--- c/src/lib/libbsp/sh/shsim/bsp_specs	(revision 86ec6edbe9851ff7e2dd0bd5412d30461cfb2f59)
+++ c/src/lib/libbsp/sh/shsim/bsp_specs	(revision 86ec6edbe9851ff7e2dd0bd5412d30461cfb2f59)
@@ -0,0 +1,23 @@
+%rename cpp old_cpp
+%rename lib old_lib
+%rename endfile old_endfile
+%rename startfile old_startfile
+%rename link old_link
+
+*cpp:
+%(old_cpp) %{qrtems: -D__embedded__} -Asystem(embedded)
+
+*lib:
+%{!qrtems: %(old_lib)} %{qrtems: --start-group \
+%{!qrtems_debug: -lrtemsall} %{qrtems_debug: -lrtemsall_g} \
+-lc -lgcc --end-group \
+%{!qnolinkcmds: -T linkcmds%s}}
+
+*startfile:
+%{!qrtems: %(old_startfile)} %{qrtems: \
+%{!qrtems_debug: start.o%s} \
+%{qrtems_debug: start_g.o%s}}
+
+*link:
+%(old_link) %{!qrtems: %(old_link)} %{qrtems: -dc -dp -N -e _start}
+
Index: c/src/lib/libbsp/sh/shsim/clock/.cvsignore
===================================================================
--- c/src/lib/libbsp/sh/shsim/clock/.cvsignore	(revision 86ec6edbe9851ff7e2dd0bd5412d30461cfb2f59)
+++ c/src/lib/libbsp/sh/shsim/clock/.cvsignore	(revision 86ec6edbe9851ff7e2dd0bd5412d30461cfb2f59)
@@ -0,0 +1,2 @@
+Makefile
+Makefile.in
Index: c/src/lib/libbsp/sh/shsim/clock/Makefile.am
===================================================================
--- c/src/lib/libbsp/sh/shsim/clock/Makefile.am	(revision 86ec6edbe9851ff7e2dd0bd5412d30461cfb2f59)
+++ c/src/lib/libbsp/sh/shsim/clock/Makefile.am	(revision 86ec6edbe9851ff7e2dd0bd5412d30461cfb2f59)
@@ -0,0 +1,33 @@
+##
+## $Id$
+##
+
+AUTOMAKE_OPTIONS = foreign 1.4
+
+PGM = $(ARCH)/clock.rel
+
+C_FILES = clockdrv.c
+C_O_FILES = $(C_FILES:%.c=$(ARCH)/%.o)
+
+OBJS = $(C_O_FILES)
+
+include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
+include $(top_srcdir)/../../../../../../automake/compile.am
+include $(top_srcdir)/../../../../../../automake/lib.am
+
+#
+# (OPTIONAL) Add local stuff here using +=
+#
+
+$(PGM): $(OBJS)
+	$(make-rel)
+
+# the .rel file built here will be put into libbsp.a by ../wrapup/Makefile
+
+all-local: $(ARCH) $(OBJS) $(PGM)
+
+.PRECIOUS: $(PGM)
+
+EXTRA_DIST = ckinit.c
+
+include $(top_srcdir)/../../../../../../automake/local.am
Index: c/src/lib/libbsp/sh/shsim/clock/clockdrv.c
===================================================================
--- c/src/lib/libbsp/sh/shsim/clock/clockdrv.c	(revision 86ec6edbe9851ff7e2dd0bd5412d30461cfb2f59)
+++ c/src/lib/libbsp/sh/shsim/clock/clockdrv.c	(revision 86ec6edbe9851ff7e2dd0bd5412d30461cfb2f59)
@@ -0,0 +1,22 @@
+/*
+ *  Instantiate the clock driver shell.
+ *
+ *  Since there is no clock source on the simulator, all we do is
+ *  make sure it will build.
+ *
+ *  $Id$
+ */
+
+#define CLOCK_VECTOR 0
+
+#define Clock_driver_support_at_tick()
+
+#define Clock_driver_support_install_isr( _new, _old ) \
+  do { _old = 0; } while(0)
+
+
+#define Clock_driver_support_initialize_hardware()
+
+#define Clock_driver_support_shutdown_hardware()
+
+#include "../../../shared/clockdrv_shell.c"
Index: c/src/lib/libbsp/sh/shsim/configure.in
===================================================================
--- c/src/lib/libbsp/sh/shsim/configure.in	(revision 86ec6edbe9851ff7e2dd0bd5412d30461cfb2f59)
+++ c/src/lib/libbsp/sh/shsim/configure.in	(revision 86ec6edbe9851ff7e2dd0bd5412d30461cfb2f59)
@@ -0,0 +1,32 @@
+dnl Process this file with autoconf to produce a configure script.
+dnl
+dnl $Id$
+
+AC_PREREQ(2.13)
+AC_INIT(bsp_specs)
+RTEMS_TOP(../../../../../..)
+AC_CONFIG_AUX_DIR(../../../../../..)
+
+RTEMS_CANONICAL_TARGET_CPU
+AM_INIT_AUTOMAKE(rtems-c-src-lib-libbsp-sh-shsim,$RTEMS_VERSION,no)
+AM_MAINTAINER_MODE
+
+RTEMS_PROG_CC_FOR_TARGET
+RTEMS_CANONICALIZE_TOOLS
+
+RTEMS_ENV_RTEMSBSP
+RTEMS_CHECK_CUSTOM_BSP(RTEMS_BSP)
+RTEMS_CHECK_BSP_CACHE(RTEMS_BSP)
+RTEMS_CANONICAL_HOST
+
+RTEMS_PROJECT_ROOT
+
+# Explicitly list all Makefiles here
+AC_OUTPUT( 
+Makefile
+clock/Makefile
+console/Makefile
+include/Makefile
+start/Makefile
+startup/Makefile
+wrapup/Makefile)
Index: c/src/lib/libbsp/sh/shsim/console/.cvsignore
===================================================================
--- c/src/lib/libbsp/sh/shsim/console/.cvsignore	(revision 86ec6edbe9851ff7e2dd0bd5412d30461cfb2f59)
+++ c/src/lib/libbsp/sh/shsim/console/.cvsignore	(revision 86ec6edbe9851ff7e2dd0bd5412d30461cfb2f59)
@@ -0,0 +1,2 @@
+Makefile
+Makefile.in
Index: c/src/lib/libbsp/sh/shsim/console/Makefile.am
===================================================================
--- c/src/lib/libbsp/sh/shsim/console/Makefile.am	(revision 86ec6edbe9851ff7e2dd0bd5412d30461cfb2f59)
+++ c/src/lib/libbsp/sh/shsim/console/Makefile.am	(revision 86ec6edbe9851ff7e2dd0bd5412d30461cfb2f59)
@@ -0,0 +1,38 @@
+##
+## $Id$
+##
+
+AUTOMAKE_OPTIONS = foreign 1.4
+
+VPATH = @srcdir@:@srcdir@/../../../shared
+
+PGM = $(ARCH)/console.rel
+
+C_FILES = console-io.c console-polled.c
+C_O_FILES = $(C_FILES:%.c=$(ARCH)/%.o)
+
+S_FILES = console-support.S
+S_O_FILES = $(S_FILES:%.S=$(ARCH)/%.o)
+
+OBJS = $(C_O_FILES) $(S_O_FILES)
+
+include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
+include $(top_srcdir)/../../../../../../automake/compile.am
+include $(top_srcdir)/../../../../../../automake/lib.am
+
+#
+# (OPTIONAL) Add local stuff here using +=
+#
+
+$(PGM): $(OBJS)
+	$(make-rel)
+
+# the .rel file built here will be put into libbsp.a by ../wrapup/Makefile
+
+all-local: $(ARCH) $(OBJS) $(PGM)
+
+.PRECIOUS: $(PGM)
+
+EXTRA_DIST = console.c
+
+include $(top_srcdir)/../../../../../../automake/local.am
Index: c/src/lib/libbsp/sh/shsim/console/console-io.c
===================================================================
--- c/src/lib/libbsp/sh/shsim/console/console-io.c	(revision 86ec6edbe9851ff7e2dd0bd5412d30461cfb2f59)
+++ c/src/lib/libbsp/sh/shsim/console/console-io.c	(revision 86ec6edbe9851ff7e2dd0bd5412d30461cfb2f59)
@@ -0,0 +1,62 @@
+/*
+ *  This file contains the hardware specific portions of the TTY driver
+ *  for the simulators stdin/out.
+ *
+ *  Logic based on newlib-1.8.2/newlib/libc/sys/sh/syscalls.c 
+ *
+ *  COPYRIGHT (c) 1989-2000.
+ *  On-Line Applications Research Corporation (OAR).
+ *
+ *  The license and distribution terms for this file may be
+ *  found in the file LICENSE in this distribution or at
+ *  http://www.OARcorp.com/rtems/license.html.
+ *
+ *  $Id$
+ */
+
+#include <bsp.h>
+#include <rtems/libio.h>
+#include <stdlib.h>
+#include <assert.h>
+
+
+#define SYS_exit        1
+#define SYS_read        3
+#define SYS_write       4
+
+
+/*
+ *  console_outbyte_polled
+ *
+ *  This routine transmits a character using polling.
+ */
+
+void console_outbyte_polled(
+  int  port,
+  char ch
+)
+{
+ return __trap34 (SYS_write, 1, &ch, 1);
+}
+
+/*
+ *  console_inbyte_nonblocking 
+ *
+ *  This routine polls for a character.
+ */
+
+int console_inbyte_nonblocking(
+  int port
+)
+{
+  unsigned char c;
+
+  return __trap34 (SYS_read, 0, &c, 1);
+}
+
+/* XXX wrong place for this */
+_sys_exit (n)
+{
+  return __trap34 (SYS_exit, n, 0, 0);
+}
+
Index: c/src/lib/libbsp/sh/shsim/console/console-support.S
===================================================================
--- c/src/lib/libbsp/sh/shsim/console/console-support.S	(revision 86ec6edbe9851ff7e2dd0bd5412d30461cfb2f59)
+++ c/src/lib/libbsp/sh/shsim/console/console-support.S	(revision 86ec6edbe9851ff7e2dd0bd5412d30461cfb2f59)
@@ -0,0 +1,21 @@
+/*
+ *  newlib-1.8.2/newlib/libc/sys/sh/trap.S
+ *
+ *  $Id$
+ */
+        .text
+        .global ___trap34
+___trap34:
+        trapa   #34
+        tst     r1,r1   ! r1 is errno
+        bt      ret
+        mov.l   perrno,r2
+        mov.l   r1,@r2
+ret:
+        rts
+        nop
+         
+        .align  2
+perrno:
+        .long   _errno
+
Index: c/src/lib/libbsp/sh/shsim/include/.cvsignore
===================================================================
--- c/src/lib/libbsp/sh/shsim/include/.cvsignore	(revision 86ec6edbe9851ff7e2dd0bd5412d30461cfb2f59)
+++ c/src/lib/libbsp/sh/shsim/include/.cvsignore	(revision 86ec6edbe9851ff7e2dd0bd5412d30461cfb2f59)
@@ -0,0 +1,2 @@
+Makefile
+Makefile.in
Index: c/src/lib/libbsp/sh/shsim/include/Makefile.am
===================================================================
--- c/src/lib/libbsp/sh/shsim/include/Makefile.am	(revision 86ec6edbe9851ff7e2dd0bd5412d30461cfb2f59)
+++ c/src/lib/libbsp/sh/shsim/include/Makefile.am	(revision 86ec6edbe9851ff7e2dd0bd5412d30461cfb2f59)
@@ -0,0 +1,25 @@
+##
+## $Id$
+##
+
+AUTOMAKE_OPTIONS = foreign 1.4
+
+H_FILES = bsp.h ../../../shared/include/coverhd.h
+
+$(PROJECT_INCLUDE):
+	$(mkinstalldirs) $@
+
+$(PROJECT_INCLUDE)/bsp.h: bsp.h
+	$(INSTALL_DATA) $< $@
+
+$(PROJECT_INCLUDE)/coverhd.h: ../../../shared/include/coverhd.h
+	$(INSTALL_DATA) $< $@
+
+TMPINSTALL_FILES += $(PROJECT_INCLUDE) $(PROJECT_INCLUDE)/bsp.h \
+    $(PROJECT_INCLUDE)/coverhd.h
+
+all-local: $(TMPINSTALL_FILES)
+
+EXTRA_DIST = bsp.h
+
+include $(top_srcdir)/../../../../../../automake/local.am
Index: c/src/lib/libbsp/sh/shsim/include/bsp.h
===================================================================
--- c/src/lib/libbsp/sh/shsim/include/bsp.h	(revision 86ec6edbe9851ff7e2dd0bd5412d30461cfb2f59)
+++ c/src/lib/libbsp/sh/shsim/include/bsp.h	(revision 86ec6edbe9851ff7e2dd0bd5412d30461cfb2f59)
@@ -0,0 +1,85 @@
+/*  bsp.h
+ *
+ *  This include file contains some definitions specific to the
+ *  JMR3904 simulator in gdb.
+ *
+ *  COPYRIGHT (c) 1989-2000.
+ *  On-Line Applications Research Corporation (OAR).
+ *
+ *  The license and distribution terms for this file may be
+ *  found in the file LICENSE in this distribution or at
+ *  http://www.OARcorp.com/rtems/license.html.
+ *
+ *  $Id$
+ */
+
+#ifndef __JMR3904_h
+#define __JMR3904_h
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+#include <rtems.h>
+#include <iosupp.h>
+#include <console.h>
+#include <clockdrv.h>
+
+/*
+ *  Define the time limits for RTEMS Test Suite test durations.
+ *  Long test and short test duration limits are provided.  These
+ *  values are in seconds and need to be converted to ticks for the
+ *  application.
+ *
+ */
+
+#define MAX_LONG_TEST_DURATION       300 /* 5 minutes = 300 seconds */
+#define MAX_SHORT_TEST_DURATION      3   /* 3 seconds */
+
+/*
+ *  Define the interrupt mechanism for Time Test 27
+ *
+ *  NOTE: Following are for XXX and are board independent
+ *
+ */
+
+#define MUST_WAIT_FOR_INTERRUPT 0
+
+#define Install_tm27_vector( handler ) 
+
+#define Cause_tm27_intr()  
+
+#define Clear_tm27_intr()  
+
+#define Lower_tm27_intr()
+
+/* Constants */
+
+/* miscellaneous stuff assumed to exist */
+
+extern rtems_configuration_table BSP_Configuration;
+
+/*
+ *  Device Driver Table Entries
+ */
+
+/*
+ * NOTE: Use the standard Console driver entry
+ */
+ 
+/*
+ * NOTE: Use the standard Clock driver entry
+ */
+
+/* functions */
+
+void bsp_cleanup( void );
+
+/* i960_isr_entry set_vector( rtems_isr_entry, unsigned int, unsigned int ); */
+
+#ifdef __cplusplus
+}
+#endif
+
+#endif
+/* end of include file */
Index: c/src/lib/libbsp/sh/shsim/start/.cvsignore
===================================================================
--- c/src/lib/libbsp/sh/shsim/start/.cvsignore	(revision 86ec6edbe9851ff7e2dd0bd5412d30461cfb2f59)
+++ c/src/lib/libbsp/sh/shsim/start/.cvsignore	(revision 86ec6edbe9851ff7e2dd0bd5412d30461cfb2f59)
@@ -0,0 +1,2 @@
+Makefile
+Makefile.in
Index: c/src/lib/libbsp/sh/shsim/start/Makefile.am
===================================================================
--- c/src/lib/libbsp/sh/shsim/start/Makefile.am	(revision 86ec6edbe9851ff7e2dd0bd5412d30461cfb2f59)
+++ c/src/lib/libbsp/sh/shsim/start/Makefile.am	(revision 86ec6edbe9851ff7e2dd0bd5412d30461cfb2f59)
@@ -0,0 +1,33 @@
+##
+## $Id$
+##
+
+AUTOMAKE_OPTIONS = foreign 1.4
+
+PGM = $(ARCH)/start.o
+
+S_FILES = start.S
+S_O_FILES = $(S_FILES:%.S=$(ARCH)/%.o)
+
+OBJS = $(S_O_FILES)
+
+include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
+include $(top_srcdir)/../../../../../../automake/compile.am
+include $(top_srcdir)/../../../../../../automake/lib.am
+
+#
+# (OPTIONAL) Add local stuff here using +=
+#
+
+$(PROJECT_RELEASE)/lib/start$(LIB_VARIANT).o: $(PGM)
+	$(INSTALL_DATA) $< $@
+
+TMPINSTALL_FILES += $(PROJECT_RELEASE)/lib/start$(LIB_VARIANT).o
+
+all-local: $(ARCH) $(OBJS) $(PGM) $(TMPINSTALL_FILES)
+
+.PRECIOUS: $(PGM)
+
+EXTRA_DIST = start.S
+
+include $(top_srcdir)/../../../../../../automake/local.am
Index: c/src/lib/libbsp/sh/shsim/start/regs.S
===================================================================
--- c/src/lib/libbsp/sh/shsim/start/regs.S	(revision 86ec6edbe9851ff7e2dd0bd5412d30461cfb2f59)
+++ c/src/lib/libbsp/sh/shsim/start/regs.S	(revision 86ec6edbe9851ff7e2dd0bd5412d30461cfb2f59)
@@ -0,0 +1,138 @@
+/*
+ * regs.S -- standard MIPS register names from
+ * newlib-1.8.2/libgloss/mips and adapted.
+ *
+ * Copyright (c) 1995 Cygnus Support
+ *
+ * The authors hereby grant permission to use, copy, modify, distribute,
+ * and license this software and its documentation for any purpose, provided
+ * that existing copyright notices are retained in all copies and that this
+ * notice is included verbatim in any distributions. No written agreement,
+ * license, or royalty fee is required for any of the authorized uses.
+ * Modifications to this software may be copyrighted by their authors
+ * and need not follow the licensing terms described here, provided that
+ * the new terms are clearly indicated on the first page of each file where
+ * they apply.
+ */
+
+/* Standard MIPS register names: */
+#define zero	$0
+#define z0	$0
+#define v0	$2
+#define v1	$3
+#define a0	$4
+#define a1	$5
+#define a2	$6
+#define a3	$7
+#define t0	$8
+#define t1	$9
+#define t2	$10
+#define t3	$11
+#define t4	$12
+#define t5	$13
+#define t6	$14
+#define t7	$15
+#define s0	$16
+#define s1	$17
+#define s2	$18
+#define s3	$19
+#define s4	$20
+#define s5	$21
+#define s6	$22
+#define s7	$23
+#define t8	$24
+#define t9	$25
+#define k0	$26	/* kernel private register 0 */
+#define k1	$27	/* kernel private register 1 */
+#define gp	$28	/* global data pointer */
+#define sp 	$29	/* stack-pointer */
+#define fp	$30	/* frame-pointer */
+#define ra	$31	/* return address */
+#define pc	$pc	/* pc, used on mips16 */
+
+#define fp0	$f0
+#define fp1	$f1
+
+/* Useful memory constants: */
+#define K0BASE		0x80000000
+#ifndef __mips64
+#define K1BASE		0xA0000000
+#else
+#define K1BASE		0xFFFFFFFFA0000000LL
+#endif
+
+#define PHYS_TO_K1(a)   ((unsigned)(a) | K1BASE)
+
+/* Standard Co-Processor 0 register numbers:
+#define C0_COUNT	$9		/* Count Register */
+#define C0_SR		$12		/* Status Register */
+#define C0_CAUSE	$13		/* last exception description */
+#define C0_EPC		$14		/* Exception error address */
+#define C0_CONFIG	$16		/* CPU configuration */
+
+/* Standard Status Register bitmasks: */
+#define SR_CU1		0x20000000	/* Mark CP1 as usable */
+#define SR_FR		0x04000000	/* Enable MIPS III FP registers */
+#define SR_BEV		0x00400000	/* Controls location of exception vectors */
+#define SR_PE		0x00100000	/* Mark soft reset (clear parity error) */
+
+#define SR_KX		0x00000080	/* Kernel extended addressing enabled */
+#define SR_SX		0x00000040	/* Supervisor extended addressing enabled */
+#define SR_UX		0x00000020	/* User extended addressing enabled */
+
+/* Standard (R4000) cache operations. Taken from "MIPS R4000
+   Microprocessor User's Manual" 2nd edition: */
+
+#define CACHE_I		(0)	/* primary instruction */
+#define CACHE_D		(1)	/* primary data */
+#define CACHE_SI	(2)	/* secondary instruction */
+#define CACHE_SD	(3)	/* secondary data (or combined instruction/data) */
+
+#define INDEX_INVALIDATE		(0)	/* also encodes WRITEBACK if CACHE_D or CACHE_SD */
+#define INDEX_LOAD_TAG			(1)
+#define INDEX_STORE_TAG			(2)
+#define CREATE_DIRTY_EXCLUSIVE		(3)	/* CACHE_D and CACHE_SD only */
+#define HIT_INVALIDATE			(4)
+#define CACHE_FILL			(5)	/* CACHE_I only */
+#define HIT_WRITEBACK_INVALIDATE	(5)	/* CACHE_D and CACHE_SD only */
+#define HIT_WRITEBACK			(6)	/* CACHE_I, CACHE_D and CACHE_SD only */
+#define HIT_SET_VIRTUAL			(7)	/* CACHE_SI and CACHE_SD only */
+
+#define BUILD_CACHE_OP(o,c)		(((o) << 2) | (c))
+
+/* Individual cache operations: */
+#define INDEX_INVALIDATE_I		BUILD_CACHE_OP(INDEX_INVALIDATE,CACHE_I)
+#define INDEX_WRITEBACK_INVALIDATE_D	BUILD_CACHE_OP(INDEX_INVALIDATE,CACHE_D)
+#define INDEX_INVALIDATE_SI             BUILD_CACHE_OP(INDEX_INVALIDATE,CACHE_SI)
+#define INDEX_WRITEBACK_INVALIDATE_SD	BUILD_CACHE_OP(INDEX_INVALIDATE,CACHE_SD)
+
+#define INDEX_LOAD_TAG_I		BUILD_CACHE_OP(INDEX_LOAD_TAG,CACHE_I)
+#define INDEX_LOAD_TAG_D                BUILD_CACHE_OP(INDEX_LOAD_TAG,CACHE_D)
+#define INDEX_LOAD_TAG_SI               BUILD_CACHE_OP(INDEX_LOAD_TAG,CACHE_SI)
+#define INDEX_LOAD_TAG_SD               BUILD_CACHE_OP(INDEX_LOAD_TAG,CACHE_SD)
+
+#define INDEX_STORE_TAG_I              	BUILD_CACHE_OP(INDEX_STORE_TAG,CACHE_I)
+#define INDEX_STORE_TAG_D               BUILD_CACHE_OP(INDEX_STORE_TAG,CACHE_D)
+#define INDEX_STORE_TAG_SI              BUILD_CACHE_OP(INDEX_STORE_TAG,CACHE_SI)
+#define INDEX_STORE_TAG_SD              BUILD_CACHE_OP(INDEX_STORE_TAG,CACHE_SD)
+
+#define CREATE_DIRTY_EXCLUSIVE_D        BUILD_CACHE_OP(CREATE_DIRTY_EXCLUSIVE,CACHE_D)
+#define CREATE_DIRTY_EXCLUSIVE_SD       BUILD_CACHE_OP(CREATE_DIRTY_EXCLUSIVE,CACHE_SD)
+
+#define HIT_INVALIDATE_I                BUILD_CACHE_OP(HIT_INVALIDATE,CACHE_I)
+#define HIT_INVALIDATE_D                BUILD_CACHE_OP(HIT_INVALIDATE,CACHE_D)
+#define HIT_INVALIDATE_SI               BUILD_CACHE_OP(HIT_INVALIDATE,CACHE_SI)
+#define HIT_INVALIDATE_SD               BUILD_CACHE_OP(HIT_INVALIDATE,CACHE_SD)
+
+#define CACHE_FILL_I                    BUILD_CACHE_OP(CACHE_FILL,CACHE_I)
+#define HIT_WRITEBACK_INVALIDATE_D      BUILD_CACHE_OP(HIT_WRITEBACK_INVALIDATE,CACHE_D)
+#define HIT_WRITEBACK_INVALIDATE_SD     BUILD_CACHE_OP(HIT_WRITEBACK_INVALIDATE,CACHE_SD)
+
+#define HIT_WRITEBACK_I                 BUILD_CACHE_OP(HIT_WRITEBACK,CACHE_I)
+#define HIT_WRITEBACK_D                 BUILD_CACHE_OP(HIT_WRITEBACK,CACHE_D)
+#define HIT_WRITEBACK_SD                BUILD_CACHE_OP(HIT_WRITEBACK,CACHE_SD)
+
+#define HIT_SET_VIRTUAL_SI		BUILD_CACHE_OP(HIT_SET_VIRTUAL,CACHE_SI)
+#define HIT_SET_VIRTUAL_SD              BUILD_CACHE_OP(HIT_SET_VIRTUAL,CACHE_SD)
+
+/*> EOF regs.S <*/
Index: c/src/lib/libbsp/sh/shsim/start/start.S
===================================================================
--- c/src/lib/libbsp/sh/shsim/start/start.S	(revision 86ec6edbe9851ff7e2dd0bd5412d30461cfb2f59)
+++ c/src/lib/libbsp/sh/shsim/start/start.S	(revision 86ec6edbe9851ff7e2dd0bd5412d30461cfb2f59)
@@ -0,0 +1,55 @@
+	.section .text
+	.global	start
+start:
+	mov.l	stack_k,r15
+
+	! zero out bss
+	mov.l	edata_k,r0
+	mov.l	end_k,r1
+	mov	#0,r2
+start_l:
+	 mov.l	r2,@r0
+	add	#4,r0
+	cmp/ge	r0,r1
+	bt	start_l
+
+#if defined (__SH3E__) || defined(__SH4_SINGLE__) || defined(__SH4__) || defined(__SH4_SINGLE_ONLY)
+	mov.l set_fpscr_k, r1
+	jsr @r1
+	mov #0,r4
+	lds r3,fpscr
+#endif /*  defined (__SH3E__) || defined(__SH4_SINGLE__) || defined(__SH4__) || defined(__SH4_SINGLE_ONLY__) */
+
+	! call the mainline	
+	mov.l	boot_card_k,r0
+	jsr	@r0
+	or	r0,r0
+
+	! call exit
+	mov	r0,r4
+	mov.l	exit_k,r0
+	jsr	@r0
+	or	r0,r0
+
+	.align 2
+#if defined (__SH3E__) || defined(__SH4_SINGLE__) || defined(__SH4__) || defined(__SH4_SINGLE_ONLY__)
+set_fpscr_k:
+	.long	___set_fpscr
+#endif /*  defined (__SH3E__) || defined(__SH4_SINGLE__) || defined(__SH4__) || defined(SH4_SINGLE_ONLY) */
+stack_k:
+	.long	_stack	
+edata_k:
+	.long	_edata
+end_k:
+	.long	_end
+boot_card_k:
+	.long	_boot_card
+exit_k:
+	.long	_exit
+
+#ifdef __ELF__
+	.section .stack,"aw"
+#else
+	.section .stack
+#endif
+_stack:	.long	0xdeaddead
Index: c/src/lib/libbsp/sh/shsim/startup/.cvsignore
===================================================================
--- c/src/lib/libbsp/sh/shsim/startup/.cvsignore	(revision 86ec6edbe9851ff7e2dd0bd5412d30461cfb2f59)
+++ c/src/lib/libbsp/sh/shsim/startup/.cvsignore	(revision 86ec6edbe9851ff7e2dd0bd5412d30461cfb2f59)
@@ -0,0 +1,2 @@
+Makefile
+Makefile.in
Index: c/src/lib/libbsp/sh/shsim/startup/Makefile.am
===================================================================
--- c/src/lib/libbsp/sh/shsim/startup/Makefile.am	(revision 86ec6edbe9851ff7e2dd0bd5412d30461cfb2f59)
+++ c/src/lib/libbsp/sh/shsim/startup/Makefile.am	(revision 86ec6edbe9851ff7e2dd0bd5412d30461cfb2f59)
@@ -0,0 +1,40 @@
+##
+## $Id$
+##
+
+AUTOMAKE_OPTIONS = foreign 1.4
+
+VPATH = @srcdir@:@srcdir@/../../../shared
+
+PGM = $(ARCH)/startup.rel
+
+C_FILES = bspclean.c bsplibc.c bsppost.c bspstart.c bootcard.c main.c sbrk.c \
+    gnatinstallhandler.c
+C_O_FILES = $(C_FILES:%.c=$(ARCH)/%.o)
+
+OBJS = $(C_O_FILES)
+
+include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
+include $(top_srcdir)/../../../../../../automake/compile.am
+include $(top_srcdir)/../../../../../../automake/lib.am
+
+#
+# (OPTIONAL) Add local stuff here using +=
+#
+
+$(PGM): $(OBJS)
+	$(make-rel)
+
+$(PROJECT_RELEASE)/lib/linkcmds: linkcmds
+	$(INSTALL_DATA) $< $@
+
+# the .rel file built here will be put into libbsp.a by ../wrapup/Makefile
+TMPINSTALL_FILES += $(PROJECT_RELEASE)/lib/linkcmds
+
+all-local: $(ARCH) $(OBJS) $(PGM) $(TMPINSTALL_FILES)
+
+.PRECIOUS: $(PGM)
+
+EXTRA_DIST = bspclean.c bspstart.c exit.c linkcmds setvec.c
+
+include $(top_srcdir)/../../../../../../automake/local.am
Index: c/src/lib/libbsp/sh/shsim/startup/bspstart.c
===================================================================
--- c/src/lib/libbsp/sh/shsim/startup/bspstart.c	(revision 86ec6edbe9851ff7e2dd0bd5412d30461cfb2f59)
+++ c/src/lib/libbsp/sh/shsim/startup/bspstart.c	(revision 86ec6edbe9851ff7e2dd0bd5412d30461cfb2f59)
@@ -0,0 +1,117 @@
+/*
+ *  This routine starts the application.  It includes application,
+ *  board, and monitor specific initialization and configuration.
+ *  The generic CPU dependent initialization has been performed
+ *  before this routine is invoked.
+ *
+ *  COPYRIGHT (c) 1989-2000.
+ *  On-Line Applications Research Corporation (OAR).
+ *
+ *  The license and distribution terms for this file may be
+ *  found in the file LICENSE in this distribution or at
+ *  http://www.OARcorp.com/rtems/license.html.
+ *
+ *  $Id$
+ */
+
+#include <string.h>
+
+#include <bsp.h>
+#include <rtems/libio.h>
+#include <rtems/libcsupport.h>
+
+/*
+ *  The original table from the application and our copy of it with
+ *  some changes.
+ */
+
+extern rtems_configuration_table Configuration;
+
+rtems_configuration_table  BSP_Configuration;
+
+rtems_cpu_table Cpu_table;
+
+char *rtems_progname;
+
+/*
+ *  Use the shared implementations of the following routines
+ */
+ 
+void bsp_postdriver_hook(void);
+void bsp_libc_init( void *, unsigned32, int );
+
+/*
+ *  Function:   bsp_pretasking_hook
+ *  Created:    95/03/10
+ *
+ *  Description:
+ *      BSP pretasking hook.  Called just before drivers are initialized.
+ *      Used to setup libc and install any BSP extensions.
+ *
+ *  NOTES:
+ *      Must not use libc (to do io) from here, since drivers are
+ *      not yet initialized.
+ *
+ */
+ 
+void bsp_pretasking_hook(void)
+{
+    extern int HeapBase;
+    extern int HeapSize;
+    void         *heapStart = &HeapBase;
+    unsigned long heapSize = (unsigned long)&HeapSize;
+    unsigned long ramSpace;
+
+    bsp_libc_init(heapStart, (unsigned32) heapSize, 0);
+
+#ifdef RTEMS_DEBUG
+    rtems_debug_enable( RTEMS_DEBUG_ALL_MASK );
+#endif
+
+}
+ 
+/*
+ *  bsp_start
+ *
+ *  This routine does the bulk of the system initialization.
+ */
+
+void bsp_start( void )
+{
+  extern int _end;
+  extern int WorkspaceBase;
+  /* Configure Number of Register Caches */
+
+  Cpu_table.pretasking_hook = bsp_pretasking_hook;  /* init libc, etc. */
+  Cpu_table.postdriver_hook = bsp_postdriver_hook;
+  Cpu_table.interrupt_stack_size = 4096;
+
+  if ( BSP_Configuration.work_space_size >(512*1024) )
+   _sys_exit( 1 );
+
+  BSP_Configuration.work_space_start = (void *) &WorkspaceBase;
+}
+
+/* XXX */
+void clear_cache( void *address, size_t n )
+{
+}
+
+/* Structure filled in by get_mem_info.  Only the size field is
+   actually used (to clear bss), so the others aren't even filled in.  */
+
+struct s_mem
+{
+  unsigned int size;
+  unsigned int icsize;
+  unsigned int dcsize;
+};
+
+
+void
+get_mem_info (mem)
+     struct s_mem *mem;
+{
+  mem->size = 0x1000000;        /* XXX figure out something here */
+}
+
Index: c/src/lib/libbsp/sh/shsim/startup/linkcmds
===================================================================
--- c/src/lib/libbsp/sh/shsim/startup/linkcmds	(revision 86ec6edbe9851ff7e2dd0bd5412d30461cfb2f59)
+++ c/src/lib/libbsp/sh/shsim/startup/linkcmds	(revision 86ec6edbe9851ff7e2dd0bd5412d30461cfb2f59)
@@ -0,0 +1,203 @@
+/*
+ * This is an adapted linker script from egcs-1.0.1 
+ *
+ * Memory layout for an SH 7032 with main memory in area 2
+ * This memory layout it very similar to that used for Hitachi's
+ * EVB with CMON in rom
+ *
+ * NOTE: The ram start address may vary, all other start addresses are fixed
+ *       Not suiteable for gdb's simulator
+ *
+ *  Authors: Ralf Corsepius (corsepiu@faw.uni-ulm.de) and
+ *           Bernd Becker (becker@faw.uni-ulm.de)
+ *
+ *  COPYRIGHT (c) 1997-1998, FAW Ulm, Germany
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
+ *
+ *
+ *  COPYRIGHT (c) 1998.
+ *  On-Line Applications Research Corporation (OAR).
+ *  Copyright assigned to U.S. Government, 1994.
+ *
+ *  The license and distribution terms for this file may be
+ *  found in the file LICENSE in this distribution or at
+ *  http://www.OARcorp.com/rtems/license.html.
+ *
+ *  $Id$
+ */
+
+OUTPUT_FORMAT("coff-sh")
+OUTPUT_ARCH(sh)
+ENTRY(_start)
+
+MEMORY
+{
+  rom           : o = 0x00000000, l = 128k
+  onchip_peri	: o = 0x05000000, l = 512
+  ram           : o = 0x0A040000, l = 256k
+
+  onchip_ram    : o = 0x0f000000, l = 8k
+}
+
+SECTIONS
+{
+  /* boot vector table */
+  .monvects 0x00000000 (NOLOAD): {
+    _monvects = . ;
+  } > rom
+
+  /* monitor play area */
+  .monram 0x0A040000 (NOLOAD) : 
+  {
+  _ramstart = .;
+  } > ram 
+
+  /* monitor vector table */
+  .vects   0x0A042000 (NOLOAD) : {
+    _vectab = . ;
+    *(.vects);
+  }
+
+  /* Read-only sections, merged into text segment: */
+
+  . = 0x0a044000 ;
+  .interp        : { *(.interp) 	}
+  .hash          : { *(.hash)		}
+  .dynsym        : { *(.dynsym)		}
+  .dynstr        : { *(.dynstr)		}
+  .gnu.version   : { *(.gnu.version)	}
+  .gnu.version_d : { *(.gnu.version_d)	}
+  .gnu.version_r : { *(.gnu.version_r)	}
+  .rel.text      :
+    { *(.rel.text) *(.rel.gnu.linkonce.t*) }
+  .rela.text     :
+    { *(.rela.text) *(.rela.gnu.linkonce.t*) }
+  .rel.data      :
+    { *(.rel.data) *(.rel.gnu.linkonce.d*) }
+  .rela.data     :
+    { *(.rela.data) *(.rela.gnu.linkonce.d*) }
+  .rel.rodata    :
+    { *(.rel.rodata) *(.rel.gnu.linkonce.r*) }
+  .rela.rodata   :
+    { *(.rela.rodata) *(.rela.gnu.linkonce.r*) }
+  .rel.got       : { *(.rel.got)		}
+  .rela.got      : { *(.rela.got)		}
+  .rel.ctors     : { *(.rel.ctors)	}
+  .rela.ctors    : { *(.rela.ctors)	}
+  .rel.dtors     : { *(.rel.dtors)	}
+  .rela.dtors    : { *(.rela.dtors)	}
+  .rel.init      : { *(.rel.init)	}
+  .rela.init     : { *(.rela.init)	}
+  .rel.fini      : { *(.rel.fini)	}
+  .rela.fini     : { *(.rela.fini)	}
+  .rel.bss       : { *(.rel.bss)		}
+  .rela.bss      : { *(.rela.bss)		}
+  .rel.plt       : { *(.rel.plt)		}
+  .rela.plt      : { *(.rela.plt)		}
+  .init          : { *(.init)	} =0
+  .plt      	 : { *(.plt)	}
+  .text   .   	 :
+  {
+    *(.text)
+    *(.stub)
+    /* .gnu.warning sections are handled specially by elf32.em.  */
+    *(.gnu.warning)
+    *(.gnu.linkonce.t*)
+  } > ram
+  _etext = .;
+  PROVIDE (etext = .);
+  .fini    .  : { *(.fini)    } =0
+  .rodata  .  : { *(.rodata) *(.gnu.linkonce.r*) }
+  .rodata1 .  : { *(.rodata1) }
+  /* Adjust the address for the data segment.  We want to adjust up to
+     the same address within the page on the next page up.  */
+  . = ALIGN(128) + (. & (128 - 1));
+  .data  .  :
+  {
+    *(.data)
+    *(.gnu.linkonce.d*)
+    CONSTRUCTORS
+  } > ram
+  .data1  . : { *(.data1) }
+  .ctors  .       :
+  {
+    ___ctors = .;
+    *(.ctors)
+    ___ctors_end = .;
+  }
+  .dtors  .       :
+  {
+    ___dtors = .;
+    *(.dtors)
+    ___dtors_end = .;
+  }
+  .got     .      : { *(.got.plt) *(.got) }
+  .dynamic .      : { *(.dynamic) }
+  /* We want the small data sections together, so single-instruction offsets
+     can access them all, and initialized data all before uninitialized, so
+     we can shorten the on-disk segment size.  */
+  .sdata   .  : { *(.sdata) }
+  _edata  =  .;
+  PROVIDE (edata = .);
+  __bss_start = .;
+  .sbss    .  : { *(.sbss) *(.scommon) }
+  .bss     .  :
+  {
+   *(.dynbss)
+   *(.bss)
+   *(COMMON)
+  } > ram
+  _end = . ;
+  PROVIDE (end = .);
+
+  _HeapBase = . ;
+  . = . + 1024 * 20 ;
+  PROVIDE( _HeapEnd = . );
+
+  _WorkSpaceBase = . ;
+  . = 0x0a080000 ;
+  PROVIDE(_WorkSpaceEnd = .);
+
+  _CPU_Interrupt_stack_low  = 0x0f000000 ;
+  _CPU_Interrupt_stack_high = _CPU_Interrupt_stack_low + 4096 ;
+
+  /* Stabs debugging sections.  */
+  .stab 0 : { *(.stab) }
+  .stabstr 0 : { *(.stabstr) }
+  .stab.excl 0 : { *(.stab.excl) }
+  .stab.exclstr 0 : { *(.stab.exclstr) }
+  .stab.index 0 : { *(.stab.index) }
+  .stab.indexstr 0 : { *(.stab.indexstr) }
+  .comment 0 : { *(.comment) }
+  /* DWARF debug sections.
+     Symbols in the DWARF debugging sections are relative to the beginning
+     of the section so we begin them at 0.  */
+  /* DWARF 1 */
+  .debug          0 : { *(.debug) }
+  .line           0 : { *(.line) }
+  /* GNU DWARF 1 extensions */
+  .debug_srcinfo  0 : { *(.debug_srcinfo) }
+  .debug_sfnames  0 : { *(.debug_sfnames) }
+  /* DWARF 1.1 and DWARF 2 */
+  .debug_aranges  0 : { *(.debug_aranges) }
+  .debug_pubnames 0 : { *(.debug_pubnames) }
+  /* DWARF 2 */
+  .debug_info     0 : { *(.debug_info) }
+  .debug_abbrev   0 : { *(.debug_abbrev) }
+  .debug_line     0 : { *(.debug_line) }
+  .debug_frame    0 : { *(.debug_frame) }
+  .debug_str      0 : { *(.debug_str) }
+  .debug_loc      0 : { *(.debug_loc) }
+  .debug_macinfo  0 : { *(.debug_macinfo) }
+  /* SGI/MIPS DWARF 2 extensions */
+  .debug_weaknames 0 : { *(.debug_weaknames) }
+  .debug_funcnames 0 : { *(.debug_funcnames) }
+  .debug_typenames 0 : { *(.debug_typenames) }
+  .debug_varnames  0 : { *(.debug_varnames) }
+
+  .stack 0x0f001ff0 : { _stack = .; *(.stack) } > onchip_ram
+  /* These must appear regardless of  .  */
+}
Index: c/src/lib/libbsp/sh/shsim/wrapup/.cvsignore
===================================================================
--- c/src/lib/libbsp/sh/shsim/wrapup/.cvsignore	(revision 86ec6edbe9851ff7e2dd0bd5412d30461cfb2f59)
+++ c/src/lib/libbsp/sh/shsim/wrapup/.cvsignore	(revision 86ec6edbe9851ff7e2dd0bd5412d30461cfb2f59)
@@ -0,0 +1,2 @@
+Makefile
+Makefile.in
Index: c/src/lib/libbsp/sh/shsim/wrapup/Makefile.am
===================================================================
--- c/src/lib/libbsp/sh/shsim/wrapup/Makefile.am	(revision 86ec6edbe9851ff7e2dd0bd5412d30461cfb2f59)
+++ c/src/lib/libbsp/sh/shsim/wrapup/Makefile.am	(revision 86ec6edbe9851ff7e2dd0bd5412d30461cfb2f59)
@@ -0,0 +1,36 @@
+##
+## $Id$
+##
+
+AUTOMAKE_OPTIONS = foreign 1.4
+
+BSP_FILES = startup clock console timer
+
+# CPU_PIECES = score
+
+include $(RTEMS_ROOT)/make/custom/@RTEMS_BSP@.cfg
+include $(top_srcdir)/../../../../../../automake/compile.am
+include $(top_srcdir)/../../../../../../automake/lib.am
+
+# bummer; have to use $foreach since % pattern subst rules only replace 1x
+OBJS = $(foreach piece, $(BSP_FILES), $(wildcard ../$(piece)/$(ARCH)/*.o)) \
+    $(wildcard ../../../../libcpu/$(RTEMS_CPU)/$(RTEMS_CPU_MODEL)/$(ARCH)/*.o) \
+    $(foreach piece, $(GENERIC_FILES), ../../../$(piece)/$(ARCH)/$(piece).rel)
+
+LIB = $(ARCH)/libbsp.a
+
+#
+# (OPTIONAL) Add local stuff here using +=
+#
+
+$(LIB): ${OBJS}
+	$(make-library)
+
+$(PROJECT_RELEASE)/lib/libbsp$(LIB_VARIANT).a: $(LIB)
+	$(INSTALL_DATA) $< $@
+
+TMPINSTALL_FILES += $(PROJECT_RELEASE)/lib/libbsp$(LIB_VARIANT).a
+
+all-local: ${ARCH} $(TMPINSTALL_FILES)
+
+include $(top_srcdir)/../../../../../../automake/local.am
